* BRWX.PRG   : Makes integrated browses into screens less a nightmare
* Author     : Jason Landry; Exchange Resources, Inc.
* CIS ID     : 74473,3256
* Address    : 1516 78th Ave N
*              Brooklyn Park, MN 55444
* Fax        : (612) 566-5477
* Versions   : v.25 - 07/07/94  Concept becomes a program.  Works only
*                               for Windows right now.
*			 : v.50 - 07/18/94  Added autofitting and fixed some bugs.
*            : v.60 - 07/20/94  Added a few commands, fixed more bugs.

*   Once you have placed '*:SCXDRV1 brwx' in the setup snippet of a screen,
*   BRWX.PRG will look for a rectangle with a '*:BRWX <table>' directive
*   in the comment snippet.  It will then create two child windows as
*   outlined in the FoxPro Developer's Guide for a browse in a screen.
*   Additional Directives Include:
*
*  *:BRWXTITLE <expc1>		   Title for the browse, e.g., "Item Detail"
*  *:BRWXFONT  <expc1>,<expn1> Font and size for browse, e.g., "Arial",9
*  *:BRWXFOR <expl>			   Logical FOR expression.  Note that any memory
*							   memory variables need to be set up in
*                              #SECTION 1
*  *:BRWXFIELDS ...            Field clause(s) as specified in Cmd Ref.
*                              e.g, desc:H="Description",price:H="Unit Price"
*  *:BRWXREFRESH ON            Adds SHOW WINDOW ... statement to SHOW GETS
*  *:BRWXPRECMD <command>	   Command executed when entering browse.
*                              for example, DO myFunction
*  *:BRWXPOSTCMD <command>     Command executed when entering GET screen
*  *:BRWXMENUS OFF             Adds 'NOMENU' to generated browse command
*  *:BRWXWHEN <function>       Adds 'WHEN function()' to BROWSE command
*
*  See the sample screens for more information.

PRIVATE mfilt,tmpcmd,mwname,mscnh,mscnw,mwfontclause,minitialdb
PRIVATE mscncolor,msaveokl1,msaveokl2,msaveokl3,msaveokl4,msaveokl5
PRIVATE mescproc,mctrltabproc,mrefreshproc,mactiveproc,minited
PRIVATE mwfont,mwfsize,mgetwin,mvstart,mvend,mhstart,mhend
PRIVATE mbrwxdb,mbrwxflds,mbrwxfor,mbrwxwhen,mbrwxfont,mbrwxtitle,mbrwxwin
PRIVATE mbrwxprecmd,mbrwxpostcmd,mautofit
PRIVATE mbfsize,mbrwxwidth,mbrwxmenu,mbrwxface,msec1,msec2,mtitleh
PRIVATE mbrwxclauses

DO updthrm WITH "Running Browse Integrator","[WINDOWS] "+PROGRAM(),0

mfilt=SET("FILTER")
SET FILTER TO platform="WINDOWS" AND !DELETED()
GO TOP

IF EMPTY(name)
	REPLACE name WITH LOWER(SYS(2015))
ENDIF
IF EMPTY(fontface)
	REPLACE fontface WITH "MS Sans Serif",fontsize WITH 9
ENDIF

mwname=name
mwfont=ALLTRIM(fontface)
mwfsize=fontsize
mwfontclause=" FONT '"+ALLTRIM(fontface)+"',"+ALLTRIM(STR(fontsize))
mscnh=HEIGHT
mscnw=WIDTH
mscncolor=" COLOR RGB(,,,"+ALLTRIM(STR(fillred))+","+ALLTRIM(STR(fillgreen))+","+ALLTRIM(STR(fillblue))+")"

mbrwxwin=LOWER(SYS(2015))
minitialdb=LOWER(SYS(2015))
msaveokl1=LOWER(SYS(2015))
msaveokl2=LOWER(SYS(2015))
msaveokl3=LOWER(SYS(2015))
msaveokl4=LOWER(SYS(2015))
msaveokl5=LOWER(SYS(2015))
minited=LOWER(SYS(2015))
mgetwin=LOWER(SYS(2015))
mescproc=LOWER(SYS(2015))
mctrltabproc=LOWER(SYS(2015))
mactivateproc=LOWER(SYS(2015))

mtitleh=(sysmetric(9)+2)/(FONTMETRIC(1,mwfont,mwfsize)+FONTMETRIC(4,mwfont,mwfsize))

mrefreshproc="brwx_ref"


LOCATE FOR objtype=7 AND wordsearch("*:BRWX ","comment")<>CHR(0)
IF FOUND()

	SET MESSAGE TO "Defining child windows"

	IF vpos>mscnh-(vpos+HEIGHT)
		mvstart=0
		mvend=vpos-.1	&& arbitrary for now
	ELSE
		mvstart=vpos+HEIGHT
		mvend=mscnh
	ENDIF
	mhstart=0
	mhend=mscnw
	mbrowdb=wordsearch("*:BRWX ","comment")
	mbrwxfont=STRTRAN(ws("*:BRWXFONT","comment",mwfontclause," FONT "),'"',"'")
	mbrwxface=SUBSTR(mbrwxfont,AT("'",mbrwxfont)+1,AT("'",mbrwxfont,2)-AT("'",mbrwxfont)-1)
	mbfsize=VAL(SUBSTR(mbrwxfont,RAT(",",mbrwxfont)+1,LEN(mbrwxfont)-1))
	mbrwxfor=ws("*:BRWXFOR","comment",""," FOR ")
	mbrwxtitle=ws("*:BRWXTITLE","comment")
	mbrwxdb=ws("*:BRWX","comment")
	mbrwxflds=ws("*:BRWXFIELDS","COMMENT","","")
	mautofit=UPPER(ws("*:BRWXAUTOFIT","COMMENT"))
	mbrwxwhen=ws("*:BRWXWHEN","COMMENT",""," WHEN ")
	mbrwxwidth=WIDTH
	mbrwxmenu=ws("*:BRWXMENU","comment")
	mbrwxclauses=ws("*:BRWXCLAUSES","comment")
	IF UPPER(mbrwxmenu)="ON"
		mbrwxmenu=""
	ELSE
		mbrwxmenu=" NOMENU "
	ENDIF
	IF !("("$mbrwxwhen) AND !EMPTY(mbrwxwhen)
		mbrwxwhen=mbrwxwhen+"()"
	ENDIF
	* Implement these later...
	*	mbrwxprecmd =ws("*:BRWXPRECMD","Comment",""," WHEN ")
	*	mbrwxpostcmd=ws("*:BRWXPOSTCMD","comment",""," WHEN ")
	*	IF !("("$mbrwxprecmd) AND !EMPTY(mbrwxprecmd)
	*		mbrwxprecmd=mbrwxprecmd+"()"
	*	ENDIF
	*	IF !("("$mbrwxpostcmd) AND !EMPTY(mbrwxpostcmd)
	*		mbrwxpostcmd=mbrwxpostcmd+"()"
	*	ENDIF

	IF UPPER(ws("*:BRWXREFRESH","comment"))<>"ON"	&& don't put anything in the refresh clause
		minited=""
	ENDIF

	tmpcmd="DEFINE WINDOW "+mbrwxwin+" FROM "+objpos()+" TO "+STR(HEIGHT+vpos-mtitleh,7,3)+","+STR(WIDTH+hpos-18/FONTMETRIC(6,mwfont,mwfsize),7,3)+" IN WINDOW "+mwname+mbrwxfont

	DELETE

	SET MESSAGE TO "Removing invalid objects"
	DELETE ALL FOR (vpos<=mvstart OR vpos>=mvend) AND !(INLIST(objtype,1,2,3,4,5,7) OR (objtype=15 AND objcode=0))

	GO TOP
	SET MESSAGE TO "Adding supporting procedures and functions"
	REPLACE proccode WITH "ON KEY LABEL ESC"+IIF(EMPTY(msaveokl1),""," &"+msaveokl1)+m.cr_lf+;
		"ON KEY LABEL ctrl+tab"+IIF(EMPTY(msaveokl2),""," &"+msaveokl2)+m.cr_lf+;
		"ON KEY LABEL ctrl+q"+IIF(EMPTY(msaveokl5),""," &"+msaveokl5)+m.cr_lf+;
		"ON KEY LABEL ctrl+end"+IIF(EMPTY(msaveokl4),""," &"+msaveokl4)+m.cr_lf+;
		"ON KEY LABEL ctrl+w"+IIF(EMPTY(msaveokl3),""," &"+msaveokl3)+m.cr_lf+m.cr_lf+;
		proccode+m.cr_lf+;
		"FUNCTION "+mactivateproc+m.cr_lf+;
		"PARAMETER mTemp"+m.cr_lf+;
		"ACTIVATE WINDOW (mTemp)"+m.cr_lf+;
		"RETURN .T."+m.cr_lf+m.cr_lf+;
		"PROCEDURE "+mescproc+m.cr_lf+;
		"ACTIVATE WINDOW "+mgetwin+m.cr_lf+;
		"CLEAR READ"+m.cr_lf+m.cr_lf+;
		"PROCEDURE "+mctrltabproc+m.cr_lf+;
		"IF UPPER(WONTOP())='"+UPPER(mgetwin)+"'"+m.cr_lf+;
		"     ACTIVATE WINDOW "+IIF(EMPTY(mbrwxtitle),mbrowdb,mbrwxtitle)+m.cr_lf+;
		"ELSE"+m.cr_lf+;
		"     ACTIVATE WINDOW "+mgetwin+m.cr_lf+;
		"ENDIF"+m.cr_lf+;
		"PROCEDURE "+mrefreshproc+m.cr_lf+;
		"SHOW WINDOW "+IIF(EMPTY(mbrwxtitle),mbrwxdb,mbrwxtitle)+" REFRESH"+m.cr_lf+;
		"RETURN"+m.cr_lf

	IF !EMPTY(minited)	&& will be empty if BRWXNOREFRESH clause found
		REPLACE SHOW WITH "IF "+minited+m.cr_lf+;
			"     SHOW WINDOW "+IIF(EMPTY(mbrwxtitle),mbrowdb,mbrwxtitle)+" REFRESH"+m.cr_lf+;
			"ELSE"+m.cr_lf+;
			"     "+minited+"=.T."+m.cr_lf+;
			"ENDIF"+m.cr_lf+SHOW
	ENDIF

	msec1=	"#SECTION 1"+m.cr_lf+;
		"*:SET ASSOCWINDS TO "+IIF(EMPTY(mbrwxtitle),mbrowdb,mbrwxtitle)+","+mgetwin+m.cr_lf+;
		"PRIVATE "+msaveokl1+","+msaveokl2+","+msaveokl3+IIF(!EMPTY(minited),","+minited,"")+m.cr_lf+;
		msaveokl1+"=ON('KEY','ESC')"+m.cr_lf+;
		msaveokl2+"=ON('KEY','CTRL+TAB')"+m.cr_lf+;
		msaveokl3+"=ON('KEY','CTRL+W')"+m.cr_lf+;
		msaveokl4+"=ON('KEY','CTRL+END')"+m.cr_lf+;
		msaveokl5+"=ON('KEY','CTRL+Q')"+m.cr_lf+;
		IIF(!EMPTY(minited),minited+"=.F."+m.cr_lf,"")
	msec2=	"#SECTION 2"+m.cr_lf+;
		"DEFINE WINDOW "+mgetwin+" NONE IN WINDOW "+mwname+" FROM "+;
		STR(mvstart,6,3)+","+STR(mhstart,6,3)+" TO "+STR(mvend,6,3)+","+STR(mhend,6,3)+;
		mwfontclause+mscncolor+m.cr_lf+;
		"ON KEY LABEL esc DO "+mescproc+m.cr_lf+;
		"ON KEY LABEL ctrl+w DO "+mescproc+m.cr_lf+;
		"ON KEY LABEL ctrl+tab DO "+mctrltabproc+m.cr_lf+;
		"ON KEY LABEL ctrl+end DO "+mescproc+m.cr_lf+;
		"ON KEY LABEL ctrl+q DO "+mescproc+m.cr_lf+;
		tmpcmd+m.cr_lf+;
		minitialdb+"=ALIAS()"+m.cr_lf+;
		"SELECT "+mbrwxdb+m.cr_lf
	msec2plus="fldc=PARSER(["+mbrwxflds+"],FLOOR("+ALLTRIM(STR(fontratio(),8,3))+"* ("+ALLTRIM(STR(mbrwxwidth,8,3))+"-27/FONTMETRIC(6,'"+mwfont+"',"+ALLTRIM(STR(mwfsize,3,0))+"))),"+ALLTRIM(STR(TXTWIDTH("1",mbrwxface,mbfsize),6,3))+",["+mautofit+"])";
		+m.cr_lf+;
		"BROWSE WINDOW "+mbrwxwin+" "+mbrwxclauses+" IN WINDOW "+mwname+mbrwxmenu+" NOWAIT SAVE &fldc "+IIF(EMPTY(mbrwxtitle),""," TITLE "+mbrwxtitle)+mbrwxfor+mbrwxwhen+m.cr_lf+;
		"IF !EMPTY("+minitialdb+")"+m.cr_lf+;
		"     SELECT ("+minitialdb+")"+m.cr_lf+;
		"ELSE"+m.cr_lf+;
		"     SELECT 0"+m.cr_lf+;
		"ENDIF"+m.cr_lf+;
		"RELEASE "+minitialdb+m.cr_lf
	DO CASE
	CASE "#SECTION 1"$UPPER(setupcode) AND "#SECTION 2"$UPPER(setupcode)
		REPLACE setupcode WITH STRTRAN(setupcode,"#SECTION 1",msec1)
		REPLACE setupcode WITH setupcode+STRTRAN(msec2+msec2plus,"#SECTION 2","")
	CASE "#SECTION 1"$UPPER(setupcode)
		REPLACE setupcode WITH STRTRAN(setupcode,"#SECTION 1",msec1)
		REPLACE setupcode WITH setupcode+m.cr_lf+msec2+msec2plus
	CASE "#SECTION 2"$UPPER(setupcode)
		REPLACE setupcode WITH setupcode+STRTRAN(msec2+msec2plus,"#SECTION 2","")
		REPLACE setupcode WITH msec1+m.cr_lf+setupcode
	OTHERWISE
		REPLACE setupcode WITH msec1+m.cr_lf+setupcode+msec2+msec2plus
	ENDCASE

	SET MESSAGE TO "Adjusting object positions within child window"

	DO WHILE !EOF()
		DO CASE
		CASE objtype>=5 AND !(vpos<mvstart OR vpos>mvend)
			IF !EMPTY(ws("*:IF","comment"))
				=wordstuff("*:IF "+mactivateproc+"('"+mgetwin+"')"+ws("*:IF","comment",""," AND (",")"),.T.,.T.,"comment")
			ELSE
				=wordstuff("*:IF "+mactivateproc+"('"+mgetwin+"')",.T.,.T.,"comment")
			ENDIF
			REPLACE vpos WITH vpos-mvstart
		CASE (INLIST(objtype,5,7) OR (objtype=15 AND objcode=0)) AND (vpos<mvstart OR vpos>mvend) && let the SAYS outside the gets remain
			IF !EMPTY(ws("*:IF","comment"))
				=wordstuff("*:IF "+mactivateproc+"('"+mwname+"')"++ws("*:IF","comment",""," AND (",")"),.T.,.T.,"comment")
			ELSE
				=wordstuff("*:IF "+mactivateproc+"('"+mwname+"')",.T.,.T.,"comment")
			ENDIF
		ENDCASE
		SKIP
	ENDDO

ENDIF
DO updthrm WITH "Running Browse Integrator","[WINDOWS] "+PROGRAM(),100
GO BOTTOM
SET FILTER TO &mfilt

FUNCTION ws
PARAMETER sf,fld,blnk,prepend,postpend
IF TYPE("blnk")="L"
	blnk=""
ENDIF
IF TYPE("prepend")="L"
	prepend=""
ENDIF
IF TYPE("postpend")="L"
	postpend=""
ENDIF
result=wordsearch(sf,fld)
IF result==CHR(0)
	result=blnk
ELSE
	result=prepend+result+postpend
ENDIF
RETURN result

FUNCTION fontratio
PARAMETER STR
PRIVATE mwfw,bwfw,bwff
mwfw=FONTMETRIC(6,mwfont,mwfsize)
bwff=SUBSTR(mbrwxfont,AT("'",mbrwxfont)+1,AT("'",mbrwxfont,2)-AT("'",mbrwxfont)-1)
bwfw=FONTMETRIC(6,bwff,mbfsize)
RETURN mwfw/bwfw
